@echo off & setlocal enableextensions
rem enabledelayedexpansion

cls
echo.
echo Ŀ
echo  M_TSICON.CMD Create a TSICON package, both in .arc and .zip formats 
echo  By Prof. Timo Salmi. Last modified Tue 24-Jul-2007                  
echo 
echo.

:: Which arc and zip programs to use
set arcprog=C:\_F\TOOLS\PKPAK.EXE
set zipprog=C:\_F\TOOLS\PKZIP.EXE

:: The location and the name of the package to be made
set targdir_=C:\_M
set targname_=TSICON12

:: An auxiliary folder where the files first are copied for the archiving
set tempdir_=C:\_M\TSICON

:: Help
if not "%~1"=="?" if not "%~1"=="/?" goto _user
echo Usage: M_TSICON
echo.
echo Builds %targdir_%\%targname_%.ARC
echo Builds %targdir_%\%targname_%.ZIP
echo Timo's Windows icons collection
goto _out

:_user
if "%USERNAME%"=="ts" if defined pcid_ goto _gawk
echo   This file is included to show how one builds a
echo   zip and an arc package with command line scripting.
echo   It is not needed by the user. Only by the author.
goto _out

:: Test that gawk.exe is available at path or in the current folder
:_gawk
for %%f in ("GAWK.EXE") do set found_="%%~$PATH:f"
if exist GAWK.EXE set found_="GAWK.EXE"
if [%found_%]==[""] (
  echo GAWK.EXE needed by the script is not available at path or current folder
  echo Get e.g. ftp://garbo.uwasa.fi/pc/unix/gawk2156.zip
  echo or ftp://garbo.uwasa.fi/win95/unix/UnxUpdates.zip
  echo.
  if not [%cmdbox%]==[true] if [%PauseIfFromDesktop%]==[true] pause
  goto _out
  )

:: Copy the relevant files for the package
:_copy
mkdir "%tempdir_%"
for %%f in ("%targdir_%\%targname_%.ARC"
            "%targdir_%\%targname_%.ZIP") do if exist "%%f" del /p "%%f"
copy "c:\_f\inf\tsicon.diz"             "%tempdir_%\file_id.diz"
copy "c:\_f\inf\tsicoinf.txt"           "%tempdir_%\"
copy "c:\_f\inf\tsiconws.txt"           "%tempdir_%\"
copy "c:\_f\xtools\m_tsicon.cmd"        "%tempdir_%\"
copy "c:\_l\timo\icons-ts\tsicon.gif"   "%tempdir_%\"
copy "c:\_l\timo\icons-ts\tsicona1.dll" "%tempdir_%\"
copy "c:\_l\timo\icons-ts\tsicona2.dll" "%tempdir_%\"
copy "c:\_l\timo\icons-ts\tsiconb1.dll" "%tempdir_%\"
copy "c:\_l\timo\icons-ts\tsiconc1.dll" "%tempdir_%\"
copy "c:\_l\timo\icons-ts\tsiconc2.dll" "%tempdir_%\"
copy "c:\_l\timo\icons-ts\tsiconc3.dll" "%tempdir_%\"
copy "c:\_l\timo\icons-ts\tsicond1.dll" "%tempdir_%\"
copy "c:\_l\timo\icons-ts\tsicond2.dll" "%tempdir_%\"
copy "c:\_l\timo\icons-ts\tsicone1.dll" "%tempdir_%\"
copy "c:\_f\inf\tsprog.txt"             "%tempdir_%\"

:: Make the (temporary) ARC version for documentation reasons
echo Brief characterization of TSICON|"%arcprog%" -ac %targdir_%\%targname_%.ARC %tempdir_%\file_id.diz
echo Document of the TSICON package  |"%arcprog%" -ac %targdir_%\%targname_%.ARC %tempdir_%\tsicoinf.txt
echo News announcements about TSICON |"%arcprog%" -ac %targdir_%\%targname_%.ARC %tempdir_%\tsiconws.txt
echo Makefile that built this package|"%arcprog%" -ac %targdir_%\%targname_%.ARC %tempdir_%\m_tsicon.cmd
echo An image map of all the icons   |"%arcprog%" -ac %targdir_%\%targname_%.ARC %tempdir_%\tsicon.gif
echo Icons, part A1                  |"%arcprog%" -ac %targdir_%\%targname_%.ARC %tempdir_%\tsicona1.dll
echo Icons, part A2                  |"%arcprog%" -ac %targdir_%\%targname_%.ARC %tempdir_%\tsicona2.dll
echo Icons, part B1                  |"%arcprog%" -ac %targdir_%\%targname_%.ARC %tempdir_%\tsiconb1.dll
echo Icons, part C1                  |"%arcprog%" -ac %targdir_%\%targname_%.ARC %tempdir_%\tsiconc1.dll
echo Icons, part C2                  |"%arcprog%" -ac %targdir_%\%targname_%.ARC %tempdir_%\tsiconc2.dll
echo Icons, part C3                  |"%arcprog%" -ac %targdir_%\%targname_%.ARC %tempdir_%\tsiconc3.dll
echo Icons, part D1                  |"%arcprog%" -ac %targdir_%\%targname_%.ARC %tempdir_%\tsicond1.dll
echo Icons, part D2                  |"%arcprog%" -ac %targdir_%\%targname_%.ARC %tempdir_%\tsicond2.dll
echo Icons, part E1                  |"%arcprog%" -ac %targdir_%\%targname_%.ARC %tempdir_%\tsicone1.dll
echo List of programs from T.Salmi   |"%arcprog%" -ac %targdir_%\%targname_%.ARC %tempdir_%\tsprog.txt
"%arcprog%" -vc %targdir_%\%targname_%
"%arcprog%" -vc %targdir_%\%targname_%|gawk '{printf"%%s\n",$0}'>%targdir_%\temp74.prn
"%arcprog%" -vc %targdir_%\%targname_%|gawk '{printf"%%s\n",substr($0,1,68)}'>%targdir_%\temp68.prn
"%arcprog%" -vc %targdir_%\%targname_%|gawk '{printf"%%s\n",substr($0,1,48)}'>%targdir_%\temp48.prn
pause

:: Make the actual ZIP package
echo Brief characterization of TSICOM|"%zipprog%" -aco %targdir_%\%targname_%.ZIP %tempdir_%\file_id.diz
echo Document of the TSICON package  |"%zipprog%" -aco %targdir_%\%targname_%.ZIP %tempdir_%\tsicoinf.txt
echo News announcements about TSICON |"%zipprog%" -aco %targdir_%\%targname_%.ZIP %tempdir_%\tsiconws.txt
echo Makefile that built this package|"%zipprog%" -aco %targdir_%\%targname_%.ZIP %tempdir_%\m_tsicon.cmd
echo An image map of all the icons   |"%zipprog%" -aco %targdir_%\%targname_%.ZIP %tempdir_%\tsicon.gif
echo Icons, part A1                  |"%zipprog%" -aco %targdir_%\%targname_%.ZIP %tempdir_%\tsicona1.dll
echo Icons, part A2                  |"%zipprog%" -aco %targdir_%\%targname_%.ZIP %tempdir_%\tsicona2.dll
echo Icons, part B1                  |"%zipprog%" -aco %targdir_%\%targname_%.ZIP %tempdir_%\tsiconb1.dll
echo Icons, part C1                  |"%zipprog%" -aco %targdir_%\%targname_%.ZIP %tempdir_%\tsiconc1.dll
echo Icons, part C2                  |"%zipprog%" -aco %targdir_%\%targname_%.ZIP %tempdir_%\tsiconc2.dll
echo Icons, part C3                  |"%zipprog%" -aco %targdir_%\%targname_%.ZIP %tempdir_%\tsiconc3.dll
echo Icons, part D1                  |"%zipprog%" -aco %targdir_%\%targname_%.ZIP %tempdir_%\tsicond1.dll
echo Icons, part D2                  |"%zipprog%" -aco %targdir_%\%targname_%.ZIP %tempdir_%\tsicond2.dll
echo Icons, part E1                  |"%zipprog%" -aco %targdir_%\%targname_%.ZIP %tempdir_%\tsicone1.dll
echo List of programs from T.Salmi   |"%zipprog%" -aco %targdir_%\%targname_%.ZIP %tempdir_%\tsprog.txt
"%zipprog%" -vc %targdir_%\%targname_%.ZIP
echo FTP archives http://garbo.uwasa.fi/ University of Vaasa, Finland|"%zipprog%" -zo %targdir_%\%targname_%.ZIP
pause

:: Clean up
:_out
for %%f in ("%tempdir_%\*.*") do if exist "%%f" del "%%f"
if exist "%tempdir_%\" rmdir "%tempdir_%"
endlocal & goto :EOF
